#include "xworkspace.h"

#define MAX_PROPERTY_SIZE 32*1024

int atomnum;
char atomname[128] = "";

char *getqueryref()
{
	if(atomnum > 9000)
		atomnum = 0;
	atomnum++;
	sprintf(atomname, "%i%s%i", clientpid, clientname, atomnum);
	return atomname;
}

int XWopenXDisplay()
{
	dpy = XOpenDisplay("");
	if(!dpy)
		return 0;
	
	scr = DefaultScreen(dpy);
	rootWin = DefaultRootWindow(dpy);
	XSetErrorHandler((XErrorHandler)XError);
	
	return 1;
}

int XError(Display *dpy, XErrorEvent *error)
{
	return 0;
}

int XWconnectToTheServer(char *clname, int clpid, long clwin)
{
	char *xwsreadydata;
	Atom atom, type_ret;
	int fmt_ret;
	unsigned long nitems_ret;
	unsigned long bytes_after_ret;

	serverpid = -1;
	atomnum = 0;
	sprintf(clientname, "%s\n%i", clname, geteuid());
	
	clientpid = clpid;
	clientwin = clwin;
	
	atom = XInternAtom(dpy, "XWReadyAtom", 0);

	if(XGetWindowProperty(dpy, rootWin, atom, 
					  0, MAX_PATH_LEN, 0, XA_STRING,
					  &type_ret, &fmt_ret, &nitems_ret, &bytes_after_ret,
					  (unsigned char**)&xwsreadydata))
		return 0;

	sscanf(xwsreadydata, "%s%i%li", servername, &serverpid, &serverwin);
	XFree(xwsreadydata);

	if(serverpid) {
		XWsendQueryToTheServer(ASKTOCONNECT, clientname);
		return 1;
	}
	return 0;
}

int XWverifyConnection()
{
	if(kill(serverpid, 0))
		return 0;
	return 1;
}

void XWsendQueryToTheServer(int key, char *data)
{
	XEvent Event;
	Atom atom, queryref;
		
	atom = XInternAtom(dpy, "XWClientQuery", 0);
	queryref = XInternAtom(dpy, getqueryref(), 0);
	
	XChangeProperty(dpy, rootWin, queryref, XA_STRING, 8,
		    PropModeReplace, (unsigned char *)data, strlen(data));

	XFlush(dpy);

	Event.xclient.type = ClientMessage;
	Event.xclient.display = dpy;
	Event.xclient.message_type = atom;
	Event.xclient.format = 32;
	Event.xclient.window = serverwin;
	Event.xclient.data.l[0] = queryref;
   Event.xclient.data.l[1] = key;
   Event.xclient.data.l[2] = clientpid;
	Event.xclient.data.l[3] = clientwin;
	Event.xclient.data.l[4] = 0;
	
	XSendEvent(dpy, serverwin, 1, NoEventMask, &Event);
	XFlush(dpy);
}
